config/routes.rb
ELMO::Application.routes.draw do

  get 'option_set_related_forms/new'
  get 'option_set_related_forms/create'
  mount JasmineRails::Engine => "/specs" if defined?(JasmineRails)

  # Special shortcut for simulating login in feature specs.
  get "test-login" => "user_sessions#test_login" if Rails.env.test?

  # For uptime checking
  get "ping" => "ping#show"

  #####################################
  # Basic routes (neither mission nor admin mode)
  scope ":locale", locale: /[a-z]{2}/, defaults: {mode: nil, mission_name: nil} do

    # Routes requiring no user.
    resources :password_resets, path: "password-resets", only: %i[new edit create update]
    resource :user_session, path: "user-session", only: %i[new create destroy]
    get "/logged-out" => "user_sessions#logged_out", as: :logged_out
    get "/login" => "user_sessions#new", as: :login

    # Routes requiring user.
    match "/logout" => "user_sessions#destroy", as: :logout, via: [:delete]
    get "/route-tests" => "route_tests#basic_mode" if Rails.env.development? || Rails.env.test?
    get "/unauthorized" => "welcome#unauthorized", as: :unauthorized

    get "/confirm-login" => "user_sessions#login_confirmation", defaults: { confirm: true }, as: :new_login_confirmation
    post "/confirm-login" => "user_sessions#process_login_confirmation", defaults: { confirm: true }, as: :login_confirmation

    # Routes with user or no user.
    root to: "welcome#index", as: :basic_root
  end

  #####################################
  # Admin-mode-only routes
  scope ":locale/admin", locale: /[a-z]{2}/, defaults: {mode: "admin", mission_name: nil} do
    resources :missions

    get "/route-tests" => "route_tests#admin_mode" if Rails.env.development? || Rails.env.test?

    # for /en/admin
    root to: "welcome#index", as: :admin_root
  end

  #####################################
  # Mission-mode-only routes
  scope ":locale/m/:mission_name", locale: /[a-z]{2}/, mission_name: /[a-z][a-z0-9]*/, defaults: {mode: "m"} do
    resources :broadcasts, only: %i[index show new create] do
      collection do
        get "possible-recipients", as: "possible_recipients", action: "possible_recipients"
        post "new-with-users", as: "new_with_users", action: "new_with_users"
      end
    end

    resources :responses do
      collection do
        post "bulk-destroy", as: "bulk_destroy", action: "bulk_destroy"

        get "possible-submitters", as: "possible_submitters", action: "possible_submitters"
        get "possible-reviewers", as: "possible_reviewers", action: "possible_reviewers"
      end
    end

    resources :sms, only: [:index] do
      collection do
        get "incoming-numbers", as: "incoming_numbers", action: "incoming_numbers", defaults: { format: "csv" }
      end
    end

    resources :sms_tests, path: "sms-tests", only: %i[new create]

    resources :reports do
      member do
        get "data"
      end
    end

    namespace :media, type: /audios|images|videos/ do
      resources :objects, path: ":type", only: %i[show create destroy]
    end

    # need to list these all separately b/c rails is dumb sometimes
    resources :answer_tally_reports, controller: "reports"
    resources :response_tally_reports, controller: "reports"
    resources :list_reports, controller: "reports"
    resources :standard_form_reports, controller: "reports"

    # special dashboard routes
    get "/info-window" => "welcome#info_window", as: :dashboard_info_window
    get "/route-tests" => "route_tests#mission_mode" if Rails.env.development? || Rails.env.test?

    # for /en/m/mission123
    root to: "welcome#index", as: :mission_root
  end

  #####################################
  # Admin mode OR mission mode routes
  scope ":locale/:mode(/:mission_name)", locale: /[a-z]{2}/, mode: /m|admin/, mission_name: /[a-z][a-z0-9]*/ do

    # the rest of these routes can have admin mode or not
    resources :forms, constraints: -> (req) { req.format == :html } do
      member do
        post "add-questions", as: "add_questions", action: "add_questions"
        put "clone"
        put "publish"
        get "choose-questions", as: "choose_questions", action: "choose_questions"
        get "sms-guide", as: "sms_guide", action: "sms_guide"
      end
    end
    resources :operations, only: %i[index show destroy] do
      collection do
        post "clear"
      end
      member do
        get "download"
      end
    end
    resources :questions do
      collection do
        post "bulk-destroy", as: "bulk_destroy", action: "bulk_destroy"
      end

      member do
        # odk needs to be able to download media prompts
        get "media_prompt", defaults: {direct_auth: "basic"}
        get "audio_prompt", defaults: {direct_auth: "basic"}, action: :media_prompt # Legacy endpoint
      end
    end
    resources :questionings, only: %i[show edit create update destroy]
    resources :qing_groups, path: "qing-groups", only: %i[new edit create show update destroy]
    resources :settings, only: %i[index update] do
      member do
        post "regenerate_override_code"
        post "regenerate_incoming_sms_token"
      end
      collection do
        get "using_incoming_sms_token_message"
      end
    end

    resources :user_imports, path: "user-imports", only: %i[new create] do
      collection do
        get :template
        post :upload
      end
    end

    resources :user_groups, only: %i[index edit update create destroy] do
      post "add_users"
      post "remove_users"
      collection do
        get "possible-groups", as: "possible_groups", action: "possible_groups"
      end
    end

    resources :form_items, path: "form-items", only: [:update]

    resources :option_sets, path: "option-sets" do
      member do
        get "child-nodes", as: "child-nodes", action: "child_nodes"
        put "clone"
        get "export", defaults: {format: "xlsx"}
      end
    end

    resources :option_set_imports, path: "option-set-imports", only: [:new, :create] do
      collection do
        get :template
        post :upload
      end
    end

    resources :option_set_related_forms, path: "option-set-related-forms", only: [:new, :create] do
      collection do
        get :template
        post :upload
      end
    end

    # import routes for standardizeable objects
    %w(forms questions option_sets).each do |k|
      post "/#{k.gsub('_', '-')}/import-standard" => "#{k}#import_standard", as: "import_standard_#{k}"
    end

    # Non-RESTful, JSON only controllers for React
    get "/condition-form-data/base" => "condition_form_data#base"
    get "/condition-form-data/option-path" => "condition_form_data#option_path"
    get "/filter-data/qings" => "filter_data#qings"

    # special routes for tokeninput suggestions
    get "/tags/suggest" => "tags#suggest", as: :suggest_tags
  end

  #####################################
  # Any mode routes
  scope ":locale(/:mode)(/:mission_name)", locale: /[a-z]{2}/, mode: /m|admin/, mission_name: /[a-z][a-z0-9]*/ do
    resources :users do
      member do
        get "login-instructions", as: "login_instructions", action: "login_instructions"
        post "regenerate_api_key"
        post "regenerate_sms_auth_code"
      end
      collection do
        post "export"
        post "bulk-destroy", as: "bulk_destroy", action: "bulk_destroy"
      end
    end
  end

  # Special SMS routes. No locale.
  def sms_submission_route(as:)
    match "/sms/submit/:token" => "sms#create", token: /[0-9a-f]{32}/, via: [:get, :post], as: as
  end
  scope "/m/:mission_name", mission_name: /[a-z][a-z0-9]*/, defaults: { mode: "m"} do
    sms_submission_route(as: :mission_sms_submission)
  end
  sms_submission_route(as: :missionless_sms_submission)

  # Special ODK routes. No locale. They are down here so that forms_path doesn't return the ODK variant.
  #
  # NOTE: Brute-force login protection happens in the rack-attack middleware,
  # which executes before routing. Be sure that all paths marked with
  # :direct_auth => true are also matched by the direct_auth? method in
  # config/initializers/rack-attack.rb
  scope "(/:locale)/m/:mission_name", mission_name: /[a-z][a-z0-9]*/, defaults: { mode: "m", direct_auth: "basic" }, constraints: -> (req) { req.format == :xml || req.format == :csv } do
    get "/formList" => "forms#index", as: :odk_form_list, defaults: {format: "xml"}
    get "/forms/:id" => "forms#show", as: :odk_form, defaults: {format: "xml"}
    get "/forms/:id/manifest" => "forms#odk_manifest", as: :odk_form_manifest, defaults: {format: "xml"}
    get "/forms/:id/itemsets" => "forms#odk_itemsets", as: :odk_form_itemsets, defaults: {format: "csv"}

    match "/submission" => "responses#odk_headers", via: [:head, :get], defaults: { format: "xml" }
    post "/submission" => "responses#create", defaults: { format: "xml" }
  end

  # API routes.
  namespace :api, defaults: { format: :json } do
    api_version module: "v1", path: { value: "v1"} do
      scope "/m/:mission_name", mission_name: /[a-z][a-z0-9]*/, defaults: {mode: "m"} do
        resources :forms, only: [:index, :show]
        resources :responses, only: :index
        resources :answers, only: :index
      end
    end
  end

  root to: redirect("/#{I18n.default_locale}")
end

app/models/qing_group.rb
# rubocop:disable Metrics/LineLength
# == Schema Information
#
# Table name: form_items
#
#  id                           :uuid             not null, primary key
#  ancestry                     :text
#  ancestry_depth               :integer          not null
#  default                      :string
#  display_if                   :string           default("always"), not null
#  group_hint_translations      :jsonb
#  group_item_name_translations :jsonb
#  group_name_translations      :jsonb
#  hidden                       :boolean          default(FALSE), not null
#  one_screen                   :boolean
#  rank                         :integer          not null
#  read_only                    :boolean
#  repeatable                   :boolean
#  required                     :boolean          default(FALSE), not null
#  type                         :string(255)      not null
#  created_at                   :datetime         not null
#  updated_at                   :datetime         not null
#  form_id                      :uuid             not null
#  form_old_id                  :integer
#  mission_id                   :uuid
#  old_id                       :integer
#  question_id                  :uuid
#  question_old_id              :integer
#
# Indexes
#
#  index_form_items_on_ancestry                 (ancestry)
#  index_form_items_on_form_id                  (form_id)
#  index_form_items_on_form_id_and_question_id  (form_id,question_id) UNIQUE
#  index_form_items_on_mission_id               (mission_id)
#  index_form_items_on_question_id              (question_id)
#
# Foreign Keys
#
#  form_items_form_id_fkey      (form_id => forms.id) ON DELETE => restrict ON UPDATE => restrict
#  form_items_mission_id_fkey   (mission_id => missions.id) ON DELETE => restrict ON UPDATE => restrict
#  form_items_question_id_fkey  (question_id => questions.id) ON DELETE => restrict ON UPDATE => restrict
#
# rubocop:enable Metrics/LineLength

class QingGroup < FormItem
  include Translatable

  translates :group_name, :group_hint, :group_item_name

  alias_method :c, :sorted_children

  def code
    group_name
  end

  def qtype_name
    nil
  end

  def child_groups
    children.where(type: "QingGroup")
  end

  def group?
    true
  end

  def option_set_id
    nil
  end

  def fragment?
    false
  end

  def multilevel_fragment?
    false
  end

  def preordered_option_nodes
    []
  end

  def normalize
    super
    self.group_item_name_translations = {} unless repeatable?
    true
  end
end

app/controllers/qing_groups_controller.rb
# frozen_string_literal: true

# Actions for QingGroups
# All requests in this controller are AJAX based.
class QingGroupsController < ApplicationController
  include ConditionFormable
  include Parameters

  # authorization via cancan
  load_and_authorize_resource

  before_action :prepare_qing_group, only: [:create]
  before_action :validate_destroy, only: [:destroy]

  def new
    @form = Form.find(params[:form_id])
    # Adding group requires same permissions as removing questions.
    authorize!(:add_questions, @form)
    @qing_group = QingGroup.new(
      form: @form,
      ancestry: @form.root_id,
      one_screen: true,
      mission: current_mission
    ).decorate
    render(partial: "modal")
  end

  def edit
    @qing_group = QingGroup.find(params[:id]).decorate

    # The QingGroupDecorator might declare this group can't do one-screen even if the property is
    # set to true. If so, we should disable the checkbox.
    @one_screen_disabled = true unless odk_decorator.one_screen_allowed?

    render(partial: "modal")
  end

  def create
    # Adding group requires same permissions as removing questions.
    authorize!(:add_questions, @qing_group.form)
    @qing_group.parent = @qing_group.form.root_group
    @qing_group.save!
    render(partial: "group", locals: {qing_group: @qing_group.decorate})
  end

  def show
    @qing_group = QingGroup.find(params[:id]).decorate
    render(partial: "modal")
  end

  def update
    @qing_group.update!(qing_group_params)
    render(partial: "group_inner", locals: {qing_group: @qing_group.decorate})
  end

  def destroy
    # Removing group requires same permissions as removing questions.
    authorize!(:remove_questions, @qing_group.form)
    @qing_group.destroy
    render(body: nil, status: :no_content)
  end

  private

  def validate_destroy
    return render(json: [], status: :not_found) unless @qing_group.children.empty?
  end

  # prepares qing_group
  def prepare_qing_group
    attrs = qing_group_params
    attrs[:ancestry] = Form.find(attrs[:form_id]).root_id
    @qing_group = QingGroup.accessible_by(current_ability).new(attrs)
    @qing_group.mission = current_mission
  end

  def qing_group_params
    condition_params = [:id, :left_qing_id, :op, :value, :_destroy, option_node_ids: []]
    translation_keys = permit_translations(params[:qing_group], :group_name, :group_hint, :group_item_name)
    params.require(:qing_group).permit(
      %i[form_id repeatable one_screen] + translation_keys,
      display_conditions_attributes: condition_params
    )
  end

  def odk_decorator
    Odk::DecoratorFactory.decorate(@qing_group.object)
  end
end

app/views/qing_groups/_group.html.erb
<li class="form-item form-item-group" data-id="<%= qing_group.id %>">
  <%= render('qing_groups/group_inner', qing_group: qing_group.decorate) %>

  <ol class="item-list">
    <% if qing_group.has_children? %>
      <% qing_group.children.order(:rank).each do |item| %>
        <%= render('forms/form_item', item: item) %>
      <% end %>
    <% end %>
  </ol>
</li>

app/views/qing_groups/_group_inner.html.erb
<div class="inner" href="<%= qing_group.group_link %>">

  <%# Spacing placeholder for styling purposes %>
  <div class="standardized"></div>

  <div class="type"><%= form_item_icon('group') %></div>

  <div class="base-info">
    <div class="wrapper"><%# Need this so we can handle wrapping nicely %>
      <div><%= qing_group.group_name %></div>
      <% if qing_group.repeatable? %>
        <%= icon_tag("repeat", title: t("qing_group.tooltips.repeatable")) %>
      <% end %>
      <% if Odk::DecoratorFactory.decorate(qing_group.object).one_screen_appropriate? %>
        <%= icon_tag("file-o", title: t("qing_group.tooltips.one_screen")) %>
      <% else %>
        <%= icon_tag("files-o", title: t("qing_group.tooltips.multi_screen")) %>
      <% end %>
    </div>
  </div>

  <div class="actions">
    <%# Ranks of questions this group refers to by display conditions.
        Used to inform the user, and data in data-ref-id used by the drag-drop system for constraint
        enforcement. %>
    <% if qing_group.refd_qings.any? %>
      <div class="refd-qing-links">
        <i class="fa fa-link"></i>
        <% qing_group.refd_qings.each do |q| %>
          <div class="refd-qing" data-ref-id="<%= q.id %>">#<span><%= q.full_dotted_rank %></span></div>
        <% end %>
      </div>
    <% end %>

    <% unless read_only %>
      <%= action_link(:edit, edit_qing_group_path(qing_group), label: false) %>
      <% if can?(:remove_questions, qing_group.form) %>
        <%= action_link(:destroy, "#", label: false, data:
              {message: I18n.t("activerecord.attributes.qing_group.delete", name: qing_group.group_name)}) %>
      <% end %>
    <% end %>
  </div>
</div> <%# End of form group info %>

app/views/qing_groups/_modal.html.erb
<div id="group-modal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">
          <%= @qing_group.modal_title %>
        </h4>
        <button type="button" class="close group-cancel" data-dismiss="modal" aria-hidden="true">&times;</button>
      </div>

      <div class="modal-body group-form">
        <%= elmo_form_for(@qing_group) do |f| %>
          <%= f.field(:form_id, type: :hidden) %>
          <%= f.field(:repeatable, type: :check_box) %>
          <% configatron.preferred_locales.each do |locale| %>
            <% lang_suffix = " (#{language_name(locale)})" %>
            <%= f.field(:"group_name_#{locale}",
                label: QingGroup.human_attribute_name("group_name") + lang_suffix) %>
            <%= f.field(:"group_hint_#{locale}",
                label: QingGroup.human_attribute_name("group_hint") + lang_suffix) %>
            <%= f.field(:"group_item_name_#{locale}",
                label: QingGroup.human_attribute_name("group_item_name") + lang_suffix,
                hint: t("activerecord.hints.qing_group.group_item_name")) %>
          <% end %>
          <% if @one_screen_disabled %>
            <%= f.field(:one_screen, content: t("qing_group.one_screen_disabled")) %>
            <%= f.hidden_field(:one_screen) %>
          <% else %>
            <%= f.field(:one_screen, type: :check_box) %>
          <% end %>
          <%= f.field(:display_logic,
                partial: "questionings/display_logic",
                locals: {form_item: @qing_group}) %>
        <% end %>
      </div>
      <% if action_name != "show" %>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary cancel" data-dismiss="modal">
            <%= I18n.t("common.cancel") %>
          </button>
          <button type="button" class="btn btn-primary save">
            <%= I18n.t("common.save") %>
          </button>
        </div>
      <% end %>
    </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->

app/views/qing_groups/_printable.html.erb
<tr class="qing-group depth <%= "depth-#{qing_group.depth}" %>">
  <td colspan="2" class="name">
    <%= qing_group.full_dotted_rank %>. <%= qing_group.group_name %>
    <% unless qing_group.group_hint.blank? %>
      <div class="hint"><%= qing_group.group_hint %></div>
    <% end %>
  </td>
</tr>